/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of XS.xs. Do not edit this file, edit XS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/MaxMind/DB/Reader/XS.xs"
/* *INDENT-ON* */
#ifdef __cplusplus
extern "C" {
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#define NEED_newRV_noinc
#include "ppport.h"
#include <sys/socket.h>
#include "maxminddb.h"

#define MATH_INT64_NATIVE_IF_AVAILABLE
#include "perl_math_int64.h"
#include "perl_math_int128.h"

#ifdef __cplusplus
}
#endif

static void iterate_record_entry(MMDB_s *mmdb, SV *data_callback,
                                 SV *node_callback, uint32_t node_num,
                                 mmdb_uint128_t ipnum, int depth,
                                 int max_depth, uint64_t record,
                                 uint8_t record_type,
                                 MMDB_entry_s *record_entry);

static SV *decode_bytes(MMDB_entry_data_s *entry_data)
{
    return newSVpvn((char *)entry_data->bytes, entry_data->data_size);
}

static SV *decode_simple_value(MMDB_entry_data_list_s **current)
{
    MMDB_entry_data_s entry_data = (*current)->entry_data;
    switch (entry_data.type) {
    case MMDB_DATA_TYPE_UTF8_STRING:
        return newSVpvn_utf8((char *)entry_data.utf8_string, entry_data.data_size, 1);
    case MMDB_DATA_TYPE_DOUBLE:
        return newSVnv(entry_data.double_value);
    case MMDB_DATA_TYPE_BYTES:
        return decode_bytes(&entry_data);
    case MMDB_DATA_TYPE_FLOAT:
        return newSVnv(entry_data.float_value);
    case MMDB_DATA_TYPE_UINT16:
        return newSVuv(entry_data.uint16);
    case MMDB_DATA_TYPE_UINT32:
        return newSVuv(entry_data.uint32);
    case MMDB_DATA_TYPE_INT32:
        return newSViv(entry_data.int32);
    case MMDB_DATA_TYPE_UINT64:
        return newSVu64(entry_data.uint64);
    case MMDB_DATA_TYPE_UINT128:
        /* We don't handle the case where uint128 is a byte array since even
         * the pure Perl MaxMind::DB::Reader requires Math::Int128, which in
         * turn requires GCC 4.4+. Therefore we know that we have an int128
         * type available if this code is compiling at all. */
        return newSVu128(entry_data.uint128);
    case MMDB_DATA_TYPE_BOOLEAN:
        /* Note to future coders - do not use PL_sv_yes, PL_sv_no, or bool_sv
         * - these all produce read-only SVs */
        return newSViv(entry_data.boolean);
    default:
        croak(
            "MaxMind::DB::Reader::XS - error decoding unknown type number %i",
            entry_data.type
            );
    }

    /* It shouldn't be possible to reach this. */
    return NULL;
}

static SV *decode_entry_data_list(MMDB_entry_data_list_s **entry_data_list);

static SV *decode_array(MMDB_entry_data_list_s **current)
{
    int size = (*current)->entry_data.data_size;

    AV *av = newAV();
    av_extend(av, size);
    for (uint i = 0; i < size; i++) {
        *current = (*current)->next;
        av_push(av, decode_entry_data_list(current));
    }

    return newRV_noinc((SV *)av);
}

static SV *decode_map(MMDB_entry_data_list_s **current)
{
    int size = (*current)->entry_data.data_size;

    HV *hv = newHV();
    hv_ksplit(hv, size);
    for (uint i = 0; i < size; i++) {
        *current = (*current)->next;
        char *key = (char *)(*current)->entry_data.utf8_string;
        int key_size = (*current)->entry_data.data_size;
        *current = (*current)->next;
        SV *val = decode_entry_data_list(current);
        (void)hv_store(hv, key, key_size, val, 0);
    }

    return newRV_noinc((SV *)hv);
}

static SV *decode_entry_data_list(MMDB_entry_data_list_s **current)
{
    switch ((*current)->entry_data.type) {
    case MMDB_DATA_TYPE_MAP:
        return decode_map(current);
    case MMDB_DATA_TYPE_ARRAY:
        return decode_array(current);
    default:
        return decode_simple_value(current);
    }
}

static SV *decode_and_free_entry_data_list(
    MMDB_entry_data_list_s *entry_data_list)
{
    MMDB_entry_data_list_s *current = entry_data_list;
    SV *sv = decode_entry_data_list(&current);
    MMDB_free_entry_data_list(entry_data_list);
    return sv;
}


static void call_node_callback(SV *node_callback, uint32_t node_num,
                               MMDB_search_node_s *node)
{
    if (!SvOK(node_callback)) {
        // nothing to do
        return;
    }

    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    EXTEND(SP, 3);
    mPUSHu(node_num);
    mPUSHs(newSVu64(node->left_record));
    mPUSHs(newSVu64(node->right_record));
    PUTBACK;

    call_sv(node_callback, G_VOID);

    FREETMPS;
    LEAVE;

    return;
}

static void call_data_callback(MMDB_s *mmdb, SV *data_callback,
                               mmdb_uint128_t ipnum, int depth,
                               MMDB_entry_s *record_entry)
{

    if (!SvOK(data_callback)) {
        // nothing to do
        return;
    }

    MMDB_entry_data_list_s *entry_data_list;
    int status = MMDB_get_entry_data_list(record_entry, &entry_data_list);
    if (MMDB_SUCCESS != status) {
        const char *error = MMDB_strerror(status);
        MMDB_free_entry_data_list(entry_data_list);
        croak(
            "MaxMind::DB::Reader::XS - Entry data error looking at offset %i: %s",
            record_entry->offset, error
            );
    }
    SV *decoded_entry = decode_and_free_entry_data_list(entry_data_list);

    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    EXTEND(SP, 3);
    mPUSHs(newSVu128(ipnum));
    mPUSHi(depth);
    mPUSHs(decoded_entry);
    PUTBACK;

    call_sv(data_callback, G_VOID);

    FREETMPS;
    LEAVE;

    return;
}

static void iterate_search_nodes(MMDB_s *mmdb, SV *data_callback,
                                  SV *node_callback, uint32_t node_num,
                                  mmdb_uint128_t ipnum,
                                  int depth,
                                  int max_depth)
{

    MMDB_search_node_s node;
    int status = MMDB_read_node(mmdb, node_num, &node);
    if (MMDB_SUCCESS != status) {
        const char *error = MMDB_strerror(status);
        croak(
            "MaxMind::DB::Reader::XS - Error reading node: %s",
            error
            );
    }

    call_node_callback(node_callback, node_num, &node);

    iterate_record_entry(mmdb, data_callback, node_callback, node_num, ipnum,
                         depth, max_depth, node.left_record,
                         node.left_record_type,
                         &node.left_record_entry);

    ipnum |= ((mmdb_uint128_t)1) << ( max_depth - depth );

    iterate_record_entry(mmdb, data_callback, node_callback, node_num, ipnum,
                         depth, max_depth, node.right_record,
                         node.right_record_type,
                         &node.right_record_entry);
}

static void iterate_record_entry(MMDB_s *mmdb, SV *data_callback,
                                 SV *node_callback, uint32_t node_num,
                                 mmdb_uint128_t ipnum, int depth,
                                 int max_depth, uint64_t record,
                                 uint8_t record_type,
                                 MMDB_entry_s *record_entry)
{

    switch (record_type) {
    case MMDB_RECORD_TYPE_INVALID:
        croak(
            "MaxMind::DB::Reader::XS - Invalid record when reading node"
            );
    case MMDB_RECORD_TYPE_SEARCH_NODE:
        iterate_search_nodes(mmdb, data_callback, node_callback, record,
                              ipnum, depth + 1, max_depth);
        return;
    case  MMDB_RECORD_TYPE_EMPTY:
        // We ignore empty branches of the search tree
        return;
    case MMDB_RECORD_TYPE_DATA:
        call_data_callback(mmdb, data_callback, ipnum, depth,
                           record_entry);
        return;
    default:
        croak("MaxMind::DB::Reader::XS - Unknown record type: %u",
              record_type);
    }
}

/* *INDENT-OFF* */

#line 275 "lib/MaxMind/DB/Reader/XS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 419 "lib/MaxMind/DB/Reader/XS.c"

XS_EUPXS(XS_MaxMind__DB__Reader__XS__open_mmdb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_MaxMind__DB__Reader__XS__open_mmdb)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, file, flags");
    {
	char *        file = (char *)SvPVbyte_nolen (ST(1))
;
	U32	flags = (unsigned long)SvUV(ST(2))
;
#line 276 "lib/MaxMind/DB/Reader/XS.xs"
        MMDB_s *mmdb;
        uint16_t status;

#line 436 "lib/MaxMind/DB/Reader/XS.c"
	MMDB_s *	RETVAL;
	dXSTARG;
#line 280 "lib/MaxMind/DB/Reader/XS.xs"
        if (file == NULL) {
            croak("MaxMind::DB::Reader::XS - No file passed to _open_mmdb()\n");
        }
        mmdb = (MMDB_s *)malloc(sizeof(MMDB_s));
        status = MMDB_open(file, flags, mmdb);

        if (MMDB_SUCCESS != status) {
            const char *error = MMDB_strerror(status);
            free(mmdb);
            croak(
                "MaxMind::DB::Reader::XS - Error opening database file \"%s\": %s",
                file, error
                );
        }

        RETVAL = mmdb;
#line 456 "lib/MaxMind/DB/Reader/XS.c"
	XSprePUSH; PUSHp((char *)&RETVAL, sizeof(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_MaxMind__DB__Reader__XS__close_mmdb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_MaxMind__DB__Reader__XS__close_mmdb)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, mmdb");
    {
	MMDB_s *	mmdb = *(MMDB_s * *)SvPV_nolen(ST(1))
;
#line 303 "lib/MaxMind/DB/Reader/XS.xs"
        MMDB_close(mmdb);
        free(mmdb);
#line 475 "lib/MaxMind/DB/Reader/XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_MaxMind__DB__Reader__XS__raw_metadata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_MaxMind__DB__Reader__XS__raw_metadata)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, mmdb");
    {
	MMDB_s *	mmdb = *(MMDB_s * *)SvPV_nolen(ST(1))
;
#line 310 "lib/MaxMind/DB/Reader/XS.xs"
        MMDB_entry_data_list_s *entry_data_list;
#line 492 "lib/MaxMind/DB/Reader/XS.c"
	SV *	RETVAL;
#line 312 "lib/MaxMind/DB/Reader/XS.xs"
        int status = MMDB_get_metadata_as_entry_data_list(mmdb, &entry_data_list);
        if (MMDB_SUCCESS != status) {
            const char *error = MMDB_strerror(status);
            MMDB_free_entry_data_list(entry_data_list);
            croak(
                "MaxMind::DB::Reader::XS - Error getting metadata: %s",
                error
                );
        }

        RETVAL = decode_and_free_entry_data_list(entry_data_list);
#line 506 "lib/MaxMind/DB/Reader/XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_MaxMind__DB__Reader__XS___data_for_address); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_MaxMind__DB__Reader__XS___data_for_address)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, mmdb, ip_address");
    {
	MMDB_s *	mmdb = *(MMDB_s * *)SvPV_nolen(ST(1))
;
	char *        ip_address = (char *)SvPVbyte_nolen (ST(2))
;
#line 331 "lib/MaxMind/DB/Reader/XS.xs"
        int gai_status, mmdb_status, get_status;
        MMDB_lookup_result_s result;
        MMDB_entry_data_list_s *entry_data_list;
#line 529 "lib/MaxMind/DB/Reader/XS.c"
	SV *	RETVAL;
#line 335 "lib/MaxMind/DB/Reader/XS.xs"
        if (!ip_address || *ip_address == '\0') {
            croak("You must provide an IP address to look up");
        }

        result = MMDB_lookup_string(mmdb, ip_address, &gai_status, &mmdb_status);
        if (0 != gai_status) {
            croak(
                "The IP address you provided (%s) is not a valid IPv4 or IPv6 address",
                ip_address);
        }

        if (MMDB_SUCCESS != mmdb_status) {
            const char *mmdb_error = MMDB_strerror(mmdb_status);
            croak(
                "MaxMind::DB::Reader::XS - Error looking up IP address \"%s\": %s",
                ip_address, mmdb_error
                );
        }

        if (result.found_entry) {
            get_status = MMDB_get_entry_data_list(&result.entry, &entry_data_list);
            if (MMDB_SUCCESS != get_status) {
                const char *get_error = MMDB_strerror(get_status);
                MMDB_free_entry_data_list(entry_data_list);
                croak(
                    "MaxMind::DB::Reader::XS - Entry data error looking up \"%s\": %s",
                    ip_address, get_error
                    );
            }
            RETVAL = decode_and_free_entry_data_list(entry_data_list);
        } else {
            RETVAL = &PL_sv_undef;
        }
#line 565 "lib/MaxMind/DB/Reader/XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_MaxMind__DB__Reader__XS__iterate_search_tree); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_MaxMind__DB__Reader__XS__iterate_search_tree)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, mmdb, data_callback, node_callback");
    {
	MMDB_s *	mmdb = *(MMDB_s * *)SvPV_nolen(ST(1))
;
	SV *	data_callback = ST(2)
;
	SV *	node_callback = ST(3)
;
#line 377 "lib/MaxMind/DB/Reader/XS.xs"
        uint32_t node_num;
        int depth;
        int max_depth;
#line 590 "lib/MaxMind/DB/Reader/XS.c"
#line 381 "lib/MaxMind/DB/Reader/XS.xs"
        node_num = 0;
        depth = 1;
        max_depth = mmdb->metadata.ip_version == 6 ? 128 : 32;
        mmdb_uint128_t ipnum = 0;

        iterate_search_nodes(mmdb, data_callback, node_callback, node_num,
            ipnum, depth, max_depth);
#line 599 "lib/MaxMind/DB/Reader/XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_MaxMind__DB__Reader__XS___read_node); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_MaxMind__DB__Reader__XS___read_node)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, mmdb, node_number");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	MMDB_s *	mmdb = *(MMDB_s * *)SvPV_nolen(ST(1))
;
	U32	node_number = (unsigned long)SvUV(ST(2))
;
#line 394 "lib/MaxMind/DB/Reader/XS.xs"
        MMDB_search_node_s node;
        int status;
#line 621 "lib/MaxMind/DB/Reader/XS.c"
#line 397 "lib/MaxMind/DB/Reader/XS.xs"
        status = MMDB_read_node(mmdb, node_number, &node);
        if (MMDB_SUCCESS != status) {
            const char *error = MMDB_strerror(status);
            croak(
                "MaxMind::DB::Reader::XS - Error trying to read node %i: %s",
                node_number, error
                );
        }
        EXTEND(SP, 2);
        mPUSHu(node.left_record);
        mPUSHu(node.right_record);
#line 634 "lib/MaxMind/DB/Reader/XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_MaxMind__DB__Reader__XS_libmaxminddb_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_MaxMind__DB__Reader__XS_libmaxminddb_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 412 "lib/MaxMind/DB/Reader/XS.xs"
        const char *v = MMDB_lib_version();
        RETVAL = newSVpv(v, strlen(v));
#line 652 "lib/MaxMind/DB/Reader/XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_MaxMind__DB__Reader__XS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_MaxMind__DB__Reader__XS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("MaxMind::DB::Reader::XS::_open_mmdb", XS_MaxMind__DB__Reader__XS__open_mmdb);
        newXS_deffile("MaxMind::DB::Reader::XS::_close_mmdb", XS_MaxMind__DB__Reader__XS__close_mmdb);
        newXS_deffile("MaxMind::DB::Reader::XS::_raw_metadata", XS_MaxMind__DB__Reader__XS__raw_metadata);
        newXS_deffile("MaxMind::DB::Reader::XS::__data_for_address", XS_MaxMind__DB__Reader__XS___data_for_address);
        newXS_deffile("MaxMind::DB::Reader::XS::_iterate_search_tree", XS_MaxMind__DB__Reader__XS__iterate_search_tree);
        newXS_deffile("MaxMind::DB::Reader::XS::__read_node", XS_MaxMind__DB__Reader__XS___read_node);
        newXS_deffile("MaxMind::DB::Reader::XS::libmaxminddb_version", XS_MaxMind__DB__Reader__XS_libmaxminddb_version);

    /* Initialisation Section */

#line 268 "lib/MaxMind/DB/Reader/XS.xs"
     PERL_MATH_INT64_LOAD_OR_CROAK;
     PERL_MATH_INT128_LOAD_OR_CROAK;

#line 701 "lib/MaxMind/DB/Reader/XS.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

